<?php

namespace App\Modules\Catalogo\Controllers;
use App\Modules\Catalogo\Models\Banco;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Yajra\Datatables\Datatables;
use Illuminate\Support\Facades\Validator;

class BancosController extends Controller
{
    protected $table;
    function __construct(){
        $this->middleware('auth');
        $this->table = new Banco();
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('Catalogo.views.bancos')->with('title','hola');
    }
    /**
     * Display a listing of the datatables list.
     *
     */
    public function getTable()
    {   
        $table = Datatables::of($this->table::all());
        $table->addColumn('action', function($row){
            $url = url('bancos/'.$row['id']);
            return view('layouts.buttons.buttons-dinamyc',['buttons'=> array(
                array('tipe'=>'edit',
                      'id_row'=>$row['id'],
                      'modal'=>'si',
                      'url'=>$url,
                      'class'=>" btn btn-primary fn_edit btn-sm",
                      'icon'=>"icon-compose"
                ),
                array('tipe'=>'delete',
                      'id_row'=>$row['id'],
                      'modal'=>'no',
                      'url'=>$url,
                      'class'=>"btn btn-danger fn_delete btn-sm",
                      'icon'=>"icon-trash"
                )
            )]);
        })->rawColumns(['action']);
        return $table->make(true);
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('Catalogo.Views.add.banco');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
       if ($request->has('action')) {
            switch ($request->input("action")) {
                case 'showtable':
                    return $this->getTable();    
                break;
                case 'add':
                    $validator = Validator::make($request->all(),[
                        'nombre' => 'required',
                        'moneda' => 'required',
                        'siglas' => 'required',
                    ] );

                   if ($validator->fails()) {
                       return response()->json(['error'=>$validator->errors()->all()]);
                    }else{
                        if ($this->table::where('siglas', '=', $request->input("siglas"))->count() > 0) {
                           return response()->json(['error'=>'Este banco ya existe']);
                        }else{
                            $this->table->nombre = $request->input("nombre");
                            $this->table->moneda = $request->input("moneda");
                            $this->table->siglas = $request->input("siglas");
                            $this->table->users_id = $request->input("iduser");
                            $this->table->save();
                            return response()->json(['success'=>'Registro agregado con exito','tablereload'=>'reload']);
                        }
                    }
                break;
                default:

                break;
            }
        }else{
             return response()->json(['error'=>'No existe ningun token por favor no borre nuesto codigo html']);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $data = $this->table::find($id);
        if (!empty($data)) {
            return view('Catalogo.views.edit.banco')->with('banco',$data);
        }else{

        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $banco = $this->table::find($id);
        if (!empty($banco)) {
            $banco->nombre = $request->input('nombre');
            $banco->moneda = $request->input('moneda');
            $banco->siglas = $request->input('siglas');
            $banco->users_id = $request->input('iduser');
            $banco->updated_at = date("Y-m-d G:i:s");
            $banco->save();
            return response()->json(['success'=>'Registro actualizado con exito','tablereload'=>'reload']);
        }else{
            return response()->json(['error'=>'El registro no existe']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $data = $this->table::find($id);
        if (!empty($data)) {
            $data->delete();
            return response()->json(['success'=>'Registro eliminado con exito']);
        }
    }
}
